* see test_spiral.prg for usage

define class spiral_therm as form
autocenter = .t.
width = 300
height = 300
caption = 'Progress Meter'
backcolor = rgb(255, 255, 255)
name = 'form1'
radius = 0
rot_progress = 500000
rot_step = 57 
radius_inc = .1
procedure setsize
 parameter sizemult
 * sizemult goes from 0.001 to .999
 * do while the radius of the circle being drawn is < half the width of the form * the multiplier
 do while thisform.radius < thisform.width/2 * sizemult
  * adjust the values that make up the color of the line
  * 0 to 255, 255 to 0, bell curve 0 to 63.75 and back down (127.5 with the *2)
  goodblue = 0+(255*(thisform.radius/(thisform.width/2)))
  goodred = 255-(255*(thisform.radius/(thisform.width/2)))
  goodgreen = (thisform.radius / (thisform.width / 2)) * goodred *2
  thisform.forecolor = rgb(goodred, goodgreen, goodblue)
  * progress goes from 0 to 85,500
  thisform.rot_progress = thisform.rot_progress + thisform.rot_step
  * create the start and end points of each line being drawn aroundthe circle
  startx = sin(thisform.rot_progress) * thisform.radius + thisform.width/2
  starty = cos(thisform.rot_progress) * thisform.radius + thisform.width/2
  endx = sin(thisform.rot_progress + thisform.rot_step) * thisform.radius + thisform.width/2
  endy = cos(thisform.rot_progress + thisform.rot_step) * thisform.radius + thisform.width/2
  thisform.line(startx, starty, endx, endy)
  thisform.radius = thisform.radius + thisform.radius_inc
 enddo
 if sizemult = 1 then
  thisform.release
 endif
endproc
enddefine

define class spirallabel as label
 extracaption = "Complete"
enddefine
